﻿using System;
using System.IO;

namespace CueMounter.DokanStructure
{
	public class DokanFileDates
	{
		public DateTime CreateTime { get; private set; }
		public DateTime AccessTime { get; private set; }
		public DateTime ModifyTime { get; private set; }

		public DokanFileDates(string file)
		{
			FileInfo fileInfo = new FileInfo(file);
			CreateTime = fileInfo.CreationTime;
			AccessTime = fileInfo.LastAccessTime;
			ModifyTime = fileInfo.LastWriteTime;
		}

		public DokanFileDates(DateTime createTime, DateTime accessTime, DateTime modifyTime)
		{
			CreateTime = createTime;
			AccessTime = accessTime;
			ModifyTime = modifyTime;
		}
	}
}
