﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CueMounter {
	public class InitializingMessage {
		public string this[string file] {
			get {
				return "Initializing "+file+"...";
			}
		}
	}

	public class ErrorInitializingMessage {
		public string this[string file, string message] {
			get {
				return "Error initializing " + file + ": " + message;
			}
		}
	}

	public class MountedMessage {
		public string this[string file] {
			get {
				return file+" mounted";
			}
		}
	}

	public static class MessageStrings {
		public const string DropToMount = "Drop .cue or audio file here to mount";
		public const string PleaseWait = "Please wait for the current operation to complete and try again";
		public const string OnlyOneFile = "Please drop only 1 file";
		public const string UnsupportedFile = "This file format is not supported";
		public const string Unmounting = "Unmounting...";
		public const string DokanNotFound = "Dokan not found. It is required and can be downloaded from the application website.";
		public const string DriveNotFound = "Drive not found. Please ensure you have mounted your files.";

		public static InitializingMessage Initializing { get { return new InitializingMessage(); } }
		public static ErrorInitializingMessage ErrorInitializing { get { return new ErrorInitializingMessage(); } }
		public static MountedMessage Mounted { get { return new MountedMessage(); } }
	}
}
