﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CueMounter {
	public class WaveProviderFactory {
		public static bool TryGetWaveProvider(string fileName) {
			string extension = Path.GetExtension(fileName).ToLower();
			if(BassWaveProvider.SupportedAudioFiles.Contains(extension)) {
				return true;
			}
			return false;
		}

		public static IWaveProvider GetWaveProvider(string fileName) {
			string extension = Path.GetExtension(fileName).ToLower();
			if(BassWaveProvider.SupportedAudioFiles.Contains(extension)) {
				return new BassWaveProvider(fileName);
			}
			return null;
		}
	}
}
